unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    h_Edit: TLabeledEdit;
    S_Edit: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Button1: TButton;
    CheckBox1: TCheckBox;
    Series3: TLineSeries;
    Series4: TPointSeries;
    Length_Edit: TLabeledEdit;
    divide_Edit: TLabeledEdit;
    Series5: TPointSeries;
    Timer1: TTimer;
    Button2: TButton;
    deg_Edit: TLabeledEdit;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    function datainput: boolean;
    procedure Drawing;
    procedure CalcXY;
    function dataset(n: integer; var d: array of double): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
  system.Math;

var
  S : double;     // x m
  h : double;     // ፷ m
  B : integer;    // 
  C : double;     // Jei[
  d : double;     // ox   m
  m : double;     // ő傽݈ʒu m
  dm :double;     // ő傽݈ʒu ox  m
  x : double;     // Βoxn_܂ł̋ m
  L : double;     // 
  deg : integer;  // DKA@
  No : integer;           // vZ
  Tf : boolean = false;   // vZ^C}[~tO

// ͏
function TForm1.datainput: boolean;
var
  ch   : integer;
  Lmin : double;
  mstr : string;
begin
  result := false;
  val(S_edit.Text, S, ch);
  if ch <> 0 then begin
    application.MessageBox('xԋɊԈႢ܂B','',0);
    exit;
  end;
  val(h_edit.Text, h, ch);
  if ch <> 0 then begin
    application.MessageBox('፷ɊԈႢ܂B','',0);
    exit;
  end;
  Lmin := sqrt(h * h + S * s);
  val(Length_edit.Text, L, ch);
  if ch <> 0 then begin
    application.MessageBox('̒ɊԈႢ܂B','',0);
    exit;
  end;
  if Lmin >= L then begin
    mstr := 'ŏl' + floatTostr(Lmin) + 'łB';
    application.MessageBox(Pchar(mstr),'',0);
    exit;
  end;
  val(divide_edit.Text, B, ch);
  if ch <> 0 then begin
    application.MessageBox('ɊԈႢ܂B','',0);
    exit;
  end;
  if B <= 0 then begin
    application.MessageBox('͂PȏɂĉB','',0);
    exit;
  end;
  val(deg_edit.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','',0);
    exit;
  end;
  if deg < 4 then begin
    application.MessageBox('܂SȏɂĉB','',0);
    exit;
  end;
  if 40 < deg then begin
    application.MessageBox('傫܂SOȉɂĉB','',0);
    exit;
  end;
  if deg mod 2 <> 0 then begin
    application.MessageBox('̒l͋ɂĉB','',0);
    exit;
  end;
  result := true;
end;

// Durand Kerner Aberth algorithm
function dka(a : array of double; var cr, ci: array of double; n: integer): boolean;
var
  r, r0, t : double;
  e, f1, f2, w1, w2 : double;
  p1, p2, a1, a2, norm: double;
  i, j, L: integer;
  ca : array of double;
  zc : double;
  StrText : string;
  eps : double;
begin
  result := true;
  setlength(ca, n + 1);

  for i := 0 to n do ca[i] := a[i];
  zc := - ca[n-1] / n;
  for i := 1 to n do
    for j := n downto i do
      ca[j-1] := ca[j-1] + ca[j] * zc;
  r := 0;
  for i := 0 to n - 1 do begin
    r0 := power(n * abs(ca[i]), 1/(n-i));
    if r < r0 then r := r0;
  end;
  Form1.Memo1.Lines.Add('R = ' + floatTostr(r));

  eps := 1E-15 * r;                         // aŎl
  for i := 1 to n  do begin                 // ar̉~ɓԊuɔzu
    t := 2 * PI / n * (i - 3.0 / 4.0);
    cr[i-1] := -a[n-1] / n + r * cos(t);    // A[oX̏l
    ci[i-1] := r * sin(t);
  end;
  L := 0;
  try
    repeat
      e := 0;
      for i := 0 to n -1 do begin
        f1 := 1;                              // q@f(zi)A=f1,=f2
        f2 := 0;                              // a[n]=1
        for j := n-1 downto 0 do begin        // z[i[@@f(z)=( c ((z+a[n-1])*z+a[n-2])*z+a[n-3])* c +a[1])*z+a[0]
          w1 := f1 * cr[i] - f2 * ci[i];      // f*z=(f1+i*f2)*(x1+i*x2)=(f1*x1-f2*x2)+i*(f1*x2+f2*x1)
          w2 := f2 * cr[i] + f1 * ci[i];
          f1 := w1 + a[j];                    // f=z+a[j]
          f2 := w2;
        end;
        p1 := 1;                              // @[j=1,N,ij](zi-zj)A=p1,=p2
        p2 := 0;
        for j := 0 to  n - 1 do begin
          if j <> i then begin
            w1 := p1 * (cr[i] - cr[j]) - p2 * (ci[i] - ci[j]);    // p*(zi-zj)
            w2 := p1 * (ci[i] - ci[j]) + p2 * (cr[i] - cr[j]);
            p1 := w1;                                             // p=(zi-zj)
            p2 := w2;
          end;
        end;

        t := p1 * p1 + p2 * p2;               // q@(f1+i*f2)/(p1+i*p2)=(f1+i*f2)(p1-i*p2)/(p1*p1+p2*p2)
        if t = 0 then begin
          application.MessageBox('Oł͊܂B(DKA[`)', '', 0);
          result := false;
          exit;
        end;
        a1 := (f1 * p1 + f2 * p2) / t;
        a2 := (f2 * p1 - f1 * p2) / t;
        norm :=sqrt(a1 * a1 + a2 * a2);
        if e < norm then e := norm;           // ől

        cr[i] := cr[i] - a1;                  // kڂ̋ߎ@zi[k+1]=zi[k]-f(zi[k])/[j=1,N,ij](zi[k]-zj[k])
        ci[i] := ci[i] - a2;
      end;
      inc(L);
    until (e < eps) or (L > 400);
  except
    on E: Exception do begin
      StrText := E.ClassName + sLineBreak + E.Message;
      StrText := StrText + sLineBreak + 'DKA@vZ[`';
      StrText := StrText + sLineBreak + 'I[o[t[玟ČvZĂ݂ĂB';
      Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
      Form1.Timer1.Enabled := False;
      Tf :=  False;
      result := False;
    end;
  end;
  Form1.Memo1.Lines.Add('DKA@@Loop = ' + intTostr(L))
end;

// sinh lpNf[^[쐬
function TForm1.dataset(n: integer; var d: array of double): boolean;
var
  T : double;
  m : integer;
  i : integer;
  StrText : string;

  function factorial(n: integer): double;       // n!
  var
    j : integer;
  begin
    result := 1;
    for j := 2 to n do result := result * j;
  end;
begin
  result := true;
  for i := 0 to n do d[i] := 0;     // zNA
  T := sqrt(L * L - h * h);
  d[n] := S - T;                    // n
  try
    for i := 1 to n div 2 do begin
      m := n - 2 * i;               // m n-2 -> 0  
      d[m] := power(S, 2 * i + 1) / factorial(2 * i + 1) / power(2, 2 * i);
    end;
  except
    on E: Exception do begin
      StrText := E.ClassName + sLineBreak + E.Message;
      StrText := StrText + sLineBreak + 'z̃f[^[쐬[`';
      Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
      Tf :=  False;
      Timer1.Enabled := False;
      result := false;;
    end;
  end;
end;

// }
// Ⴂ̎xʒu
procedure TForm1.Drawing;
const
  KN = 500;
var
  xn  : double;
  xd, dx : double;
  y   : double;
  i   : integer;
begin
  dx := S / KN;
  // }
  for i := 0 to KN do begin
    xn := i * dx;                       // vZʒu
    xd := abs(xn - m);                  // őo݈ʒű
    y := C * (cosh(xd / C) - 1) - dm;   //  Ⴂ̎xʒuƂČvZ
    Series1.AddXY(xn, y);
  end;
  // Βo݈ʒuʉߐڐ
  Series3.AddXY(0, 0 - d);              // Βo݈ʒuʉߌXΐ Ⴂ
  Series3.AddXY(S, h - d);              // Βo݈ʒuʉߌXΐ 
  // xʒu@Βoxn_@ە\
  Series4.AddXY(0, 0);                  // Ⴂ̎xʒu
  y := h / S * x - d;                   // ΒoxyW
  Series4.AddXY(x, y);                  // Βoxxy
  Series4.AddXY(S, h);                  // ̎xʒu
end;

// ʒǔvZ
procedure TForm1.CalcXY;
var
  Ls : double;
  Sb : double;
  xs, y : double;
  n  : integer;
begin
  for n := 1 to B - 1 do begin
    Ls := L / B * n;                                // ̒
    Sb := C * (arcSinh(Ls / C - sinh(m / C))) + m;  // ̎xʒu
    xs := Sb - m;                                   // ݌vZʒu
    y := C * (cosh(xs / C) - 1) - dm;               //  Ⴂ̎xʒuƂČvZ
    Series5.AddXY(Sb, y);                           // ʒu
  end;
end;

// vZ̎s @Jei[߂܂
// ̌Ot쐬
procedure TForm1.Button1Click(Sender: TObject);
var
  s1  : double;
  lmin, lmax  : double;
  bmin, bmax  : double;
  mg          : double;
  ab : array of double;
  cr : array of double;
  ci : array of double;
  n, i, j : integer;
  li : int64;
  StrText, scou : string;
  fd : double;
  ch : integer;
  cn : array of double;
  Lc : double;
  Lm : double;

  // ۂߏ
  procedure roundfd(var d: double);
  begin
    if abs(d) < 1E5 then begin           // 0.00001 ȉ̏ꍇ
      li := round(d * 1E8);              // _8ȉۂ
      d := li / 1E8;
    end;
  end;

begin

  Timer1.Enabled := False;
  if not datainput then exit;
  button1.Enabled := False;
  n := deg;
  // Ŕz̊m
  setlength(ab, n + 1);
  setlength(cr, n);
  setlength(ci, n);
  setlength(cn, 2);

  // zɃf[^[Zbg
  if not dataset(n, ab) then begin
    Button1.Enabled := true;
    timer1.Enabled :=  False;
    Tf :=  False;
    exit;
  end;
  j := 0;
  // z擪̒lPɐݒ
  try
    for i := n-1 downto 0 do begin
      ab[i] := ab[i] / ab[n];
    end;
    ab[n] := 1;
  except
    on E: Exception do begin
      StrText := E.ClassName + sLineBreak + E.Message;
      StrText := StrText + sLineBreak + 'z̐擪Pɂ鏈';
      j := 1;                   // ZG[tOZbg
    end;
  end;
  if j = 1 then begin           // ZG[
    Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
    Button1.Enabled := true;
    timer1.Enabled :=  False;
    Tf :=  False;
    exit;
  end;

  memo1.Clear;
  Lm := (L - sqrt(S * S + h * h)) / L;
  if Lm <= 1E-11 then
    memo1.Lines.Add('w蒷ɋ߂vZ덷傫Ȃ܂B');

 // zf[^[\
  if checkbox2.Checked then begin
    memo1.Lines.Add('zf[^[ n ̓[');
    memo1.Lines.Add(' n= ' + intTostr(n));
    for i := n downto 0 do begin
      if i mod 2 = 0 then  begin
        scou := 'n' + inttostr(i) + '= ' + floatTostr(ab[i]);
        memo1.Lines.Add(scou);
      end;
    end;
  end;
  // dka@vZ@Jei[C̒l߂܂
  if not dka(ab, cr, ci, n) then begin
    Button1.Enabled := true;
    timer1.Enabled :=  False;
    Tf :=  False;
    exit;
  end;

  // dka@@vZʕ\
  if Checkbox2.Checked then
    for i := 0 to n-1 do begin
      fd := cr[i];                          // 
      roundfd(fd);                          // lꍇ_8ȉۂ
      scou := 'x' + inttostr(i + 1) + '= ' + floatTostr(fd);
      ch := length(scou);
      ch := 28 - ch;
      for j := 0 to ch do scou := scou + ' ';
      fd := ci[i];                          // 
      roundfd(fd);                          // _8ȉۂ
      memo1.Lines.Add(scou + floatTostr(fd) + ' i');
    end;

  // Čo ꏊ  x+-̓ӏΒl͓l
  j := 0;
  for i := 0 to n-1 do begin
    if abs(ci[i]) < 1E-8 then begin
      fd := cr[i];
      if j <= 1 then begin
        cn[j] := fd;
      end;
      inc(j);
    end;
  end;
  if (j = 0) or (j > 2) then begin
    if j = 0 then
      StrText := 'DKA@Z܂łB';
    if j > 2 then
      StrText := 'DKA@ł̌vZ@̉\܂B';
    Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
    Button1.Enabled := true;
    timer1.Enabled :=  False;
    Tf :=  False;
    exit;
  end;
  // vZʕ\
  C := abs(cn[0]);                    // cn[0]cn[1]̐Βl͓
  memo1.Lines.Add('Jei[@b@' + floatTostr(C));
  m := S / 2 - C * arcsinh(h / (2 * C * sinh(S / 2 / C)));
  memo1.Lines.Add('ő傽݈ʒu@@' + floatTostr(m));
  Lc := C * (sinh(m / c) + sinh((S - m) / C));
  memo1.Lines.Add('vZl@Lc@' + floatTostr(Lc));
  memo1.Lines.Add('vZ@dL@' + floatTostr(L - Lc));
  s1 := abs(m * 2);
  dm := C * (cosh(s1 / 2 / C) - 1);
  memo1.Lines.Add('őʒu ox@dm@' + floatTostr(dm));
  x := m + C * arcsinh(h / S);
  memo1.Lines.Add('Βoxʒu@@ ' + floatTostr(x));
  d := x / S * h + C * (cosh(m / C) - cosh(arcsinh(h / S)));
  memo1.Lines.Add('Βox@@@@' + floatTostr(d));
  memo1.Lines.Add('@@@@' + floatTostr(sqrt(h * h + S * S)));
  if h > 0 then begin
    lmin := -d;
    lmax := h;
  end
  else begin
    lmin := -d + h;
    lmax := 0;
  end;
  bmin := 0;
  bmax := S;
  // OtcXP[ݒ
  if bmax > lmax - lmin then begin
    mg := (bmax - (lmax - lmin)) / 2;
    lmax := lmax + mg;
    lmin := lmin - mg;
  end
  else begin
    mg := ((lmax - lmin) - bmax) / 2;
    bmin := bmin - mg;
    bmax := bmax + mg;
  end;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  Series5.Clear;
  if checkbox1.Checked then begin
    Series2.AddXY(bmin, lmax);
    Series2.AddXY(bmin, lmin);
    Series2.AddXY(bmax, lmin);
  end;
  application.ProcessMessages;
  // Ot\
  Drawing;                        // Ot
  CalcXY;                         // _\
  application.ProcessMessages;
  if tf then Timer1.Enabled := True
        else button1.Enabled := true;
end;

// eXgvZX^[gXgbv
procedure TForm1.Button2Click(Sender: TObject);
var
  ch : integer;
begin
  checkbox2.Checked := false;
  divide_Edit.Text := '5';
  Timer1.Interval := 20;
  if Tf then begin
    Tf :=  False;
    timer1.Enabled :=  False;
    Button1.Enabled := True;
  end
  else begin
    val(S_Edit.Text, S, ch);
    if ch <> 0 then exit;
    val(h_Edit.Text, h, ch);
    if ch <> 0 then exit;
    timer1.Enabled :=  True;
    Tf := True;
    Button1.Enabled := False;
    No := round(sqrt(S * S + h * h) + 1);     // eXgvZ
    Length_Edit.Text := intTostr(No);
  end;
end;

// eXgvZJԂ^C}[
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Length_Edit.Text := intTostr(No);
  Button1Click(nil);
  inc(No);
  if No > 500 then No := round(sqrt(S * S + h * h) + 1);
end;

end.
